/*
 * Jukebox3D / esp Engine
 *
 * Copyright (C) 2005, 2007 Sylvain Pasquet (Sylvain.pasquet@gmail.com - pasquet.sylvain2@wanadoo.fr)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

/***************************************************************************
 *            main.h
 ****************************************************************************/

/**ViewDebugMessage**/
//#define DEBUG_CFG
//#define DEBUG_OPT
//#define DEBUG_MAIN
//#define DEBUG_COVER
//#define DEBUG_TIMER
//#define DEBUG_IMGLIB
//#define DEBUG_OGLLIB
//#define DEBUG_OGLPAN
//#define DEBUG_LIBFILE
//#define DEBUG_CLLBCKS

//LANGAGE
//#define FR 1
#define EN

/**MAX memory allocated for messages**/
#define MAX_ENTRY 5
/**Maximum openGL object**/
#define MAX_OBJECT 256
/**Reserved internal static object**/
#define RESERVED_OBJECT 10

/**MAXSTRLIB**/
#define MAX_LENGTH	256

#define EspUseSDL
//#define EspUseDevil

/**STRUCTURE******************************************************************/
/**Structures for managing sponsors/text display**/
typedef struct {
	char   cFontPath[256] ;
	int	   iFontSize      ;
	int    iSpaceLine     ;/**   Space between line                                  **/
	int    iTextAlign     ;
	gfloat red            ;
    gfloat green          ;
    gfloat blue           ;
} font_desc;
/**Toolbar**/
typedef struct {
	GLuint  Play    ;
	GLuint  Stop    ;
	GLuint  Next    ;
	GLuint  Prev    ;
} ToolbarSkin;

/**Sponsors/messaging system**/
typedef struct {
	char    cMessage[256];
	GLuint  cTexture    ;
	int     cX,cY,cW,cH ;
	GLfloat cTexcoord[4];
} StructTxtMsg          ;

/**Txt Entry, can be a group of 5 lines or 1 picture**/
typedef struct {
	int	type            ;
	char	label[64]   ;
/*	char	*cPath      ;*/
	StructTxtMsg cMsg[5];
	GLfloat red         ;
    GLfloat green       ;
    GLfloat blue        ;
} StrucTxtEntry         ;

typedef struct {
gboolean __alive__           ;/**   Main openGL scene is active ?					  **/
int      __only__            ;/**   Only show the OGL window    					  **/
char     CurrentPlay[512]    ;/**   CurrentPlay image path        					  **/
int	     iNbrEntrySpon       ;/**   For know how many messages group are stored		  **/
int	     iNbrEntryObj        ;/**   For know how many 3D object are stored   		  **/
double   __dColumnSize__     ;/**   Estimated size of one opengl unit				  **/
int 	 __iMode__		     ;/**   Mode for Edit,viewing, camera					  **/
int      __model__           ;/**   3D model style                                    **/
int      __style_anim__      ;/**   Rotation style									  **/
float    __speed__           ;/**   Var used to set speed rotation			          **/
int	     __ActSpons__	     ;/**   Var used to detect if Sponsors system is used     **/
int      __UpdSpons__        ;/**   Indicate need to update memory to screen display  **/
float    __fTimeSpons__      ;/**   Value between text rotation                       **/
float    __aWorldColor__[3]  ;/**   RGB and Fog qty for the environnement             **/
GLubyte	 __LastClicked__     ;/**   Contain ID of last clicked item on panel		  **/
int      __LiveTexRefresh__  ;/**   Flag used to know when texture need to be reloaded  **/
int      __iInitTextEffect__ ;/**   Flag used for enable voluntary text effect          **/
int      __iInitCoverEffect__;/**   Flag used for enable voluntary cover effect         **/
int      __iAlwaysDispInf__  ;/**   Is the playing information need to be always display**/
float    __fCurPlaySize__    ;/**   **/
int      __iActCurPlayRef__  ;/**   If reflexion on current playing is enable           **/
int      __iActArchRef__     ;/**   Same for archive reflexion                          **/
float    __fArchiveSize__    ;/**   **/
float    __aArchivePos__[3]  ;/**   Archive position x,y,z                              **/
float    __fGroundPos__      ;/**   Sea level                                           **/
int      __iHideToolbar__    ;
int      __iArchiveMode__    ;
int      __iCurrentPlay__    ;
int      __iFullScreen__	 ;
float    fTextFade;
int	      ptTexte        ; // Need to know what message will be displayed
/*int      __aObjectPaintOrder__[MAX_OBJECT]; Maybe for a futur random painting**/
} MyOglScene;

typedef struct {
	float   x       ;
	float   y       ;
	float   z       ;
	float   fWidth  ;
	float   fHeight ;
	float   fAngle  ;
	int     fx      ;
	int     hidden  ;
	GLuint  hTexture;
    gchar   sPath  [512];
	GLfloat red     ;
    GLfloat green   ;
    GLfloat blue    ;
} MyGLObject        ;

typedef struct {
char __sHOME__         [128];
char __sTheme__        [256];
char __sTbSkin__       [256];
char __sTbCurSkin__    [256];
char __sBgSkin__       [256];
char __sBgCurSkin__    [256];
char __sDefaultTheme__ [256];
char __sCurrentTheme__ [256];
char __sCoverPath__    [256];
char __sDataPath__     [256];
char __sGladeMain__    [256];
char __sGladeOpt__     [256];
char __sGladeOgl__     [256];
char __sCurrentScript__[256];
} EspEnvironment;

typedef struct {
	int enable;
	int Pending;
	int TimeOut;	
} DynamicPicture;

typedef struct {
  int   iFxState ;
  int   iFxLock  ;
  int   iFxMode  ;
  float fFxValue1;
  float fFxValue2;
  float fFxValue3;
} FxStruct       ;

/*
typedef struct {
	int       hidden;
	GtkWidget *hWndWidget  ;
} GuiWinStack       ;
*/
extern StrucTxtEntry    *DataTxtEntry    ;
extern MyOglScene       *OglScene        ;
extern EspEnvironment   *j3denv          ;
extern DynamicPicture   *QueryCover	     ;
extern MyGLObject	    *OglObject       ;
extern font_desc        *font_struct     ;
extern ToolbarSkin      *j3dtb           ;
extern FxStruct         *ToolbarFx       ;
