/*
 * Jukebox3D / esp Engine v2
 *
 * Copyright (C) 2005, 2007 Sylvain Pasquet (Sylvain.pasquet@gmail.com - pasquet.sylvain2@wanadoo.fr)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
/*************************************************
 *            LibOptions.c   			         *
 *************************************************/
#include <stdlib.h>
#include <stdio.h>
#include <gtk/gtk.h>
#include <string.h>
#include <glade/glade-xml.h>
#include <GL/gl.h>
#include <GL/glu.h>

#include "../include/main.h"
#include "../include/language.h"
#include "../include/interface_ogl.h"
#include "../include/interface_options.h"
int CreateTreeView(void)
{
	int pt=0;
	char *type;
	GtkListStore  *store;
	GtkTreeIter    iter;

	if (OglScene->iNbrEntrySpon!=0)
	{
	    store = gtk_list_store_new (2, G_TYPE_STRING, G_TYPE_STRING);
		while (pt<OglScene->iNbrEntrySpon)
		{
			switch (DataTxtEntry[pt].type)
			{

				case(0):
					type=TYPE1;
					break;
				case(1):
					type=TYPE2;
					break;
				default:
					type=TYPE1;
				break;
			}
			/*g_print("LOG-OptionLib.c::CreateTreeView: Ajout d'une entree -> %s\n",DataTxtEntry[pt].label);*/
 			gtk_list_store_append (store, &iter);
			gtk_list_store_set (store, &iter,
            	          0, DataTxtEntry[pt].label,
                	      1,type,
                    	  -1);
			pt=pt+1;

		}
		return 0;
	}else{
            store = gtk_list_store_new (2, G_TYPE_STRING, G_TYPE_STRING);
		return 1;

	}

	return 0;
}

void
GetSlideValue(GtkWidget* widget, gpointer data) {
	gchar* sLabel;
	gint iValue;

	/* Recuperation de la valeur de la scrollbar */
	iValue = gtk_range_get_value(GTK_RANGE(widget));
	/* Creation du nouveau label */
	sLabel = g_strdup_printf("%d", iValue);
	/*g_print("Valeur: %s \n",sLabel);*/
	OglScene->__speed__=(atof(sLabel)/100);
	g_free(sLabel);
  return;

}


void
GetSpaceValue(GtkWidget* widget, gpointer data) {
	/* Recuperation de la valeur de la scrollbar */
    font_struct->iSpaceLine = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(XmlOption.spinbutton2));
    ReConfigureText();
  return;

}
void
GetArcSize(GtkWidget* widget, gpointer data) {
	gint iValue;

	/* Recuperation de la valeur de la scrollbar */
	iValue = gtk_range_get_value(GTK_RANGE(widget));
	/*g_print("Valeur: %s \n",sLabel);*/
	OglScene->__fArchiveSize__=iValue/10.00;
  return;

}
void
GetBkgWidth(GtkWidget* widget, gpointer data) {
	gint iValue;

	/* Recuperation de la valeur de la scrollbar */
	iValue = gtk_range_get_value(GTK_RANGE(widget));
	/*g_print("Valeur: %s \n",sLabel);*/
	OglObject[1].fWidth=iValue/10.00;
  return;

}
void
GetBkgHeight(GtkWidget* widget, gpointer data) {
	gint iValue;

	/* Recuperation de la valeur de la scrollbar */
	iValue = gtk_range_get_value(GTK_RANGE(widget));
	/*g_print("Valeur: %s \n",sLabel);*/
	OglObject[1].fHeight=iValue/10.00;
  return;

}
void
GetPlaySize(GtkWidget* widget, gpointer data) {
	gint iValue;

	/* Recuperation de la valeur de la scrollbar */
	iValue = gtk_range_get_value(GTK_RANGE(widget));
	/*g_print("Valeur: %s \n",sLabel);*/
	OglScene->__fCurPlaySize__=iValue/10.00;
  return;

}
void UpSpon(GtkWidget* widget, gpointer data)
{
    #ifdef DEBUG_OPT
        g_print("LOG-OptionLib.c::UpSpon: Actif \n");
	#endif
    OglObject[2].y=OglObject[2].y-0.5;
    if (OglScene->__alive__)
	{
        ReConfigureText();
	}
	return;
}

void DownSpon(GtkWidget* widget, gpointer data)
{
    #ifdef DEBUG_OPT
        g_print("LOG-OptionLib.c::DownSpon: Actif \n");
	#endif
    OglObject[2].y=OglObject[2].y+0.5;
    if (OglScene->__alive__)
	{
        ReConfigureText();
	}
    return;
}

void LeftSpon(GtkWidget* widget, gpointer data)
{
    #ifdef DEBUG_OPT
        g_print("LOG-OptionLib.c::LeftSpon: Actif \n");
	#endif
    OglObject[2].x=OglObject[2].x-0.5;
    if (OglScene->__alive__)
	{
        ReConfigureText();
	}
	return;
}

void RightSpon(GtkWidget* widget, gpointer data)
{
    #ifdef DEBUG_OPT
        g_print("LOG-OptionLib.c::RightSpon: Actif \n");
	#endif
    OglObject[2].x=OglObject[2].x+0.5;
    if (OglScene->__alive__)
	{
        ReConfigureText();
	}
	return;
}

void RightToolbar(GtkWidget* widget, gpointer data)
{
    #ifdef DEBUG_OPT
        g_print("LOG-OptionLib.c::RightToolbar: Actif \n");
	#endif
    /**Configure Player Play**/
	OglObject[3].x =  OglObject[3].x+0.2;
	/*OglObject[3].y = -3.0;
	OglObject[3].z =  0.0;*/
	/**Configure Player Stop**/
	OglObject[4].x=OglObject[3].x+1;
	/*OglObject[4].y=OglObject[3].y;
	OglObject[4].z=OglObject[3].z;*/
    /**Configure Player Prev**/
	OglObject[5].x=OglObject[3].x+2;
	/*OglObject[5].y=OglObject[3].y;
	OglObject[5].z=OglObject[3].z;*/
	/**Configure Player Next**/
	OglObject[6].x=OglObject[3].x+3;
	/*OglObject[6].y=OglObject[3].y;
	OglObject[6].z=OglObject[3].z;*/
	return;
}
void LeftToolbar(GtkWidget* widget, gpointer data)
{
    #ifdef DEBUG_OPT
        g_print("LOG-OptionLib.c::LeftToolbar: Actif \n");
	#endif
    /**Configure Player Play**/
	OglObject[3].x =  OglObject[3].x-0.2;
	/*OglObject[3].y = -3.0;
	OglObject[3].z =  0.0;*/
	/**Configure Player Stop**/
	OglObject[4].x=OglObject[3].x+1;
	/*OglObject[4].y=OglObject[3].y;
	OglObject[4].z=OglObject[3].z;*/
    /**Configure Player Prev**/
	OglObject[5].x=OglObject[3].x+2;
	/*OglObject[5].y=OglObject[3].y;
	OglObject[5].z=OglObject[3].z;*/
	/**Configure Player Next**/
	OglObject[6].x=OglObject[3].x+3;
	/*OglObject[6].y=OglObject[3].y;
	OglObject[6].z=OglObject[3].z;*/
	return;
}
void DownToolbar(GtkWidget* widget, gpointer data)
{
    #ifdef DEBUG_OPT
        g_print("LOG-OptionLib.c::DownToolbar: Actif \n");
	#endif

    /**Configure Player Play**/
	OglObject[3].y = OglObject[3].y-0.2;
	/**Configure Player Stop**/
    OglObject[4].y=OglObject[3].y;
    /**Configure Player Prev**/
	OglObject[5].y=OglObject[3].y;
	/**Configure Player Next**/
    OglObject[6].y=OglObject[3].y;
	return;
}
void UpToolbar(GtkWidget* widget, gpointer data)
{
    #ifdef DEBUG_OPT
        g_print("LOG-OptionLib.c::UpToolbar: Actif \n");
	#endif

    /**Configure Player Play**/
	OglObject[3].y = OglObject[3].y+0.2;
	/**Configure Player Stop**/
    OglObject[4].y=OglObject[3].y;
    /**Configure Player Prev**/
	OglObject[5].y=OglObject[3].y;
	/**Configure Player Next**/
    OglObject[6].y=OglObject[3].y;
	return;
}
gchar*
GetRbData(GtkWidget* widget)
{
	GSList *pList;
	const gchar *sLabel="";

	/* Recuperation de la liste des boutons */
	pList = gtk_radio_button_get_group(GTK_RADIO_BUTTON(widget));

	/* Parcours de la liste */
	while(pList)
	{
		/* Le bouton est il selectionne */
		if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(pList->data)))
		{
		/* OUI -> on copie le label du bouton */
		sLabel = (gchar*)gtk_button_get_label(GTK_BUTTON(pList->data));
		/* On met la liste a NULL pour sortir de la boucle */
		pList = NULL;
		}
		else
		{
		/* NON -> on passe au bouton suivant */
		pList = g_slist_next(pList);
        	}
    	}

return (gchar*)sLabel;
}
void
CollectData()
{

	/*GdkColor colorA;
	GdkColor colorB;*/
	GdkColor ColWorld;
    GdkColor ColBkg;
	GdkColor ColorTexte;
/**On recupere le model 3D selectionnee************************************************/
	gchar *sLabelA;
	gchar *sPlayer;
	/*gchar *sTheme;*/
	/*gchar *sLabelB;*/
    gchar *sAnimA;
    /*gchar *sAnimB;*/
/*	gchar *sLabelRot;*/
	/*gchar *sLabelPart;*/
	gchar *sTextAlign;
	/*char  TmpTheme[128];*/
/*	gchar *sStyleTeam;*/
		/*g_print("Saving particule settings \n");*/
    gtk_color_button_get_color(GTK_COLOR_BUTTON(XmlOption.ColWorld), &ColWorld);
	OglScene->__aWorldColor__[0]=ColWorld.red/65535.0;
	OglScene->__aWorldColor__[1]=ColWorld.green/65535.0;
	OglScene->__aWorldColor__[2]=ColWorld.blue/65535.0;

    gtk_color_button_get_color(GTK_COLOR_BUTTON(XmlOption.colorbutton6), &ColBkg);
	OglObject[1].red  =ColBkg.red/65535.0;
	OglObject[1].green=ColBkg.green/65535.0;
	OglObject[1].blue =ColBkg.blue/65535.0;

    if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(XmlOption.checkbutton5))!=TRUE)
	{OglObject[1].hidden=1;}
	else
    {OglObject[1].hidden=0;}

	/*sLabel=GetRbData(XmlOption.radiobutton1);*/
	/*g_print("Valeur sLabel: %s\n", sLabel);*/

	sPlayer = gtk_combo_box_get_active_text (GTK_COMBO_BOX (XmlOption.ComboPlayer));

	if (strcmp(sPlayer, AMAROK) == 0)
	{
	    /*strcpy(OglScene->__iScript__,"/usr/share/jukebox3d-0.3.0/scripts/amarok");
	    */
        strcpy(j3denv->__sCurrentScript__,j3denv->__sDataPath__);
        j3denv->__sCurrentScript__[strlen(j3denv->__sCurrentScript__)]='\0';
        strcat(j3denv->__sCurrentScript__ , "scripts/amarok");
        j3denv->__sCurrentScript__[strlen(j3denv->__sCurrentScript__)]='\0';
    }

	if (strcmp(sPlayer, RHYTHMBOX) == 0)
	{
	    /*strcpy(OglScene->__iScript__,"/usr/share/jukebox3d-0.3.0/scripts/rhythmbox");*/
        strcpy(j3denv->__sCurrentScript__,j3denv->__sDataPath__);
        j3denv->__sCurrentScript__[strlen(j3denv->__sCurrentScript__)]='\0';
        strcat(j3denv->__sCurrentScript__ , "scripts/rhythmbox");
        j3denv->__sCurrentScript__[strlen(j3denv->__sCurrentScript__)]='\0';
    }

	if (strcmp(sPlayer, EXAILE) == 0)
	{
	    /*strcpy(OglScene->__iScript__,"/usr/share/jukebox3d-0.3.0/scripts/exaile");*/
        strcpy(j3denv->__sCurrentScript__,j3denv->__sDataPath__);
        j3denv->__sCurrentScript__[strlen(j3denv->__sCurrentScript__)]='\0';
        strcat(j3denv->__sCurrentScript__ , "scripts/exaile");
        j3denv->__sCurrentScript__[strlen(j3denv->__sCurrentScript__)]='\0';

	    }
	if (strcmp(sPlayer, MPD) == 0)
	{
	    /*strcpy(OglScene->__iScript__,"/usr/share/jukebox3d-0.3.0/scripts/exaile");*/
        strcpy(j3denv->__sCurrentScript__,j3denv->__sDataPath__);
        j3denv->__sCurrentScript__[strlen(j3denv->__sCurrentScript__)]='\0';
        strcat(j3denv->__sCurrentScript__ , "scripts/mpc");
        j3denv->__sCurrentScript__[strlen(j3denv->__sCurrentScript__)]='\0';

	    }
    #ifdef DEBUG
		g_print("LOG-OptionLib.c::CollectData: OglScene->__iScript__ -> %s\n",OglScene->__iScript__);
    #endif
    /*sLabelA= (char *) malloc(99*sizeof(char));*/
    sLabelA = gtk_combo_box_get_active_text (GTK_COMBO_BOX (XmlOption.ComboFormeA));
    #ifdef DEBUG
		g_print("LOG-OptionLib.c::CollectData: XmlOption.ComboFormeA -> %s\n",sLabelA);
    #endif
	if (strcmp(sLabelA, CUBE) == 0)
	{OglScene->__model__=0;}
	if (strcmp(sLabelA, RECTANGLE) == 0)
	{OglScene->__model__=1;}
	if (strcmp(sLabelA, PLAT) == 0)
	{OglScene->__model__=2;}
    if (strcmp(sLabelA, DRAPEAU) == 0)
	{OglScene->__model__=3;}
    if (strcmp(sLabelA, RIEN) == 0)
	{OglScene->__model__=4;}
    if (strcmp(sLabelA, CDBOX) == 0)
	{OglScene->__model__=5;}

	/**Archive mode**/
    if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(XmlOption.checkbutton3))!=TRUE)
	{
        OglScene->__iArchiveMode__=0;
        #ifdef DEBUG
            g_print("LOG-OptionLib.c::CollectData: Disabling archive mode \n");
        #endif
	}else{
        OglScene->__iArchiveMode__=1;
        #ifdef DEBUG
            g_print("LOG-OptionLib.c::CollectData: Enabling archive mode \n");
        #endif
	}


    if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(XmlOption.checkbutton6))!=TRUE)
	{
        OglScene->__iActCurPlayRef__=0;
        #ifdef DEBUG
            g_print("LOG-OpitonLib.c::CollectData: Disabling archive mode \n");
        #endif
	}else{
        OglScene->__iActCurPlayRef__=1;
        #ifdef DEBUG
            g_print("LOG-OpitonLib.c::CollectData: Enabling archive mode \n");
        #endif
	}


    if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(XmlOption.checkbutton7))!=TRUE)
	{
        OglScene->__iActArchRef__=0;
        #ifdef DEBUG
            g_print("LOG-OpitonLib.c::CollectData: Disabling archive mode \n");
        #endif
	}else{
        OglScene->__iActArchRef__=1;
        #ifdef DEBUG
            g_print("LOG-OpitonLib.c::CollectData: Enabling archive mode \n");
        #endif
	}
	/**Always display info**/
    if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(XmlOption.checkbutton4))!=TRUE)
	{
        OglScene->__iAlwaysDispInf__=1;
        #ifdef DEBUG
            g_print("LOG-OpitonLib.c::CollectData: Disabling always info mode \n");
        #endif
	}else{
        OglScene->__iAlwaysDispInf__=0;
        #ifdef DEBUG
            g_print("LOG-OpitonLib.c::CollectData: Enabling always info mode \n");
        #endif
	}

    /*sLabelB = gtk_combo_box_get_active_text (GTK_COMBO_BOX (XmlOption.ComboFormeB));
    #ifdef DEBUG
		g_print("LOG-OpitonLib.c::CollectData: XmlOption.ComboFormeB -> %s\n",sLabelB);
    #endif
	if (strcmp(sLabelB, CUBE) == 0)
	{OglScene->__styleB__=0;}

	if (strcmp(sLabelB, RECTANGLE) == 0)
	{OglScene->__styleB__=1;}

	if (strcmp(sLabelB, PLAT) == 0)
	{OglScene->__styleB__=2;}

    if (strcmp(sLabelB, DRAPEAU) == 0)
	{OglScene->__styleB__=3;}

    if (strcmp(sLabelB, RIEN) == 0)
	{OglScene->__styleB__=4;}*/


/***************************************************************************************/
	/*sLabelRot=GetRbData(XmlOption.radiobutton4);*/
	/*g_print("Valeur sLabelRot: %s\n", sLabelRot);*/
    sAnimA = gtk_combo_box_get_active_text (GTK_COMBO_BOX (XmlOption.ComboAnimA));
    #ifdef DEBUG
		g_print("LOG-OpitonLib.c::CollectData: XmlOption.ComboAnimA -> %s\n",sAnimA);
    #endif
	if (strcmp(sAnimA, R360H1) == 0)
	{OglScene->__style_anim__=0;}

	if (strcmp(sAnimA, R360H2) == 0)
	{OglScene->__style_anim__=1;}


	if (strcmp(sAnimA, R360V1) == 0)
	{OglScene->__style_anim__=2;}

	if (strcmp(sAnimA, R360V2) == 0)
	{OglScene->__style_anim__=3;}

	if (strcmp(sAnimA, RNOROT) == 0)
	{OglScene->__style_anim__=4;}


    /*sAnimB = gtk_combo_box_get_active_text (GTK_COMBO_BOX (XmlOption.ComboAnimB));
    #ifdef DEBUG
		g_print("LOG-OpitonLib.c::CollectData: XmlOption.ComboAnimB -> %s\n",sAnimB);
    #endif
	if (strcmp(sAnimB, R360H1) == 0)
	{OglScene->__style_animB__=0;}

	if (strcmp(sAnimB, R360H2) == 0)
	{OglScene->__style_animB__=1;}


	if (strcmp(sAnimB, R360V1) == 0)
	{OglScene->__style_animB__=2;}

	if (strcmp(sAnimB, R360V2) == 0)
	{OglScene->__style_animB__=3;}

	if (strcmp(sAnimB, RNOROT) == 0)
	{OglScene->__style_animB__=4;}*/

	/*sStyleTeam=GetRbData(XmlOption.radiobutton9);*/
	/*g_print("Valeur sStyleTeam: %s\n", sStyleTeam);*/
	/*if (strcmp(sStyleTeam, "Normal ( 2 équipes )") == 0)
	{OglScene->__iModeTeam__=0;}

	if (strcmp(sStyleTeam, "Aucune") == 0)
	{OglScene->__iModeTeam__=1;}


	if (strcmp(sStyleTeam, "Equipe A seulement") == 0)
	{OglScene->__iModeTeam__=2;}

	if (strcmp(sStyleTeam, "Equipe B seulement") == 0)
	{OglScene->__iModeTeam__=3;}
*/


	/**!Debug affiche la selection du fichier
       GtkWidget *pInfo = gtk_message_dialog_new (GTK_WINDOW(pWindow),
           GTK_DIALOG_MODAL,
           GTK_MESSAGE_INFO,
           GTK_BUTTONS_OK,
          "Vous avez choisi : %s", (char)sLabel);
       gtk_dialog_run(GTK_DIALOG(pInfo));
       gtk_widget_destroy(pInfo);**/


	/**Recuperation info sponsors**/

	/*if (iTmpSpon==1)
	{*/
		/*g_print("Saving sponsors settings \n");*/
		strcpy(font_struct->cFontPath,(const char *)gtk_combo_box_get_active_text (GTK_COMBO_BOX(XmlOption.combobox1)));
		/*g_print("Font: ./fonts/%s\n",font_sponsors.cFontPath);*/
		gtk_color_button_get_color(GTK_COLOR_BUTTON(XmlOption.ColTexte), &ColorTexte);
		font_struct->red=ColorTexte.red/65535.0;
		font_struct->green=ColorTexte.green/65535.0;
		font_struct->blue=ColorTexte.blue/65535.0;
		font_struct->iFontSize = gtk_spin_button_get_value_as_int (GTK_SPIN_BUTTON(XmlOption.spinbutton1));
		/*g_print("Size: %i\n",font_sponsors.iFontSize);*/
		/*OglScene->__fTimeSpons__ = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(XmlOption.spinbutton3));*/
		/**TODO: verify nbr message >0**/
		OglScene->__ActSpons__=1;
		OglScene->__UpdSpons__=1;
	/*}*/

	/**Recuperation info particle **/
	/*if (iTmpPart==1)
	{
		gtk_color_button_get_color(GTK_COLOR_BUTTON(XmlOption.ColTeamA), &colorA);
		gtk_color_button_get_color(GTK_COLOR_BUTTON(XmlOption.ColTeamB), &colorB);

		__pColPartA__.red=colorA.red/65535.0;
		__pColPartA__.green=colorA.green/65535.0;
		__pColPartA__.blue=colorA.blue/65535.0;

		__pColPartB__.red=colorB.red/65535.0;
		__pColPartB__.green=colorB.green/65535.0;
		__pColPartB__.blue=colorB.blue/65535.0;

		#ifdef DEBUG
            g_print("ColTeamA Pixel: %u\n",colorA.pixel);
            g_print("ColTeamB Pixel: %u\n",colorB.pixel);
            g_print("ColTeamA Red: %u\n",colorA.red);
            g_print("ColTeamA Red 255: %f\n",__pColPartA__.red);
            g_print("ColTeamA green: %u\n",colorA.green);
            g_print("ColTeamA green 255: %f\n",__pColPartA__.green);
            g_print("ColTeamA blue: %u\n",colorA.blue);
            g_print("ColTeamA blue 255: %f\n",__pColPartA__.blue);
            g_print("ColTeamB Red: %u\n",colorB.red);
            g_print("ColTeamB green: %u\n",colorB.green);
            g_print("ColTeamB blue: %u\n",colorB.blue);
		#endif

		sLabelPart=GetRbData(XmlOption.radiobutton13);

		if (strcmp(sLabelPart, "Double Jet") == 0)
            {
            OglScene->__iModePart__=1;
            }else{
            OglScene->__iModePart__=0;
            }
        OglScene->__AlivPart__=1;
	}else
	{
	    OglScene->__AlivPart__=0;
    }*/

    sTextAlign=GetRbData(XmlOption.radiobutton1);
    if (strcmp(sTextAlign, LEFT) == 0)
    {
        font_struct->iTextAlign=0;
    }
    if (strcmp(sTextAlign, RIGHT) == 0)
    {
        font_struct->iTextAlign=1;
    }
    if (strcmp(sTextAlign, CENTER) == 0)
    {
        font_struct->iTextAlign=2;
    }
    #ifdef DEBUG
        g_print("LOG-OptionLib.c::OptActPart: sTextAlign -> %s font_sponsors.iTextAlign -> %i\n",
                                              sTextAlign,
                                              font_struct->iTextAlign);
    #endif
    /*if (iTmpFog==1)
    {
        OglScene->__ActFog__=1;
        OglScene->__FogQty__ = gtk_spin_button_get_value_as_float (GTK_SPIN_BUTTON(XmlOption.spinbutton2));
	    #ifdef DEBUG

            g_print("LOG-OptionLib.c::OptActPart: OglScene->__FogQty__ -> %f \n",OglScene->__FogQty__);

		#endif
    }else{
        OglScene->__ActFog__=0;
    }*/
    //CreateTheme();
    //ReadTheme (TmpTheme);
    /*char sTempTheme[128];
    strcpy(sTempTheme,j3denv->__sTheme__);
    sTempTheme[strlen(j3denv->__sTheme__)]='\0';
    strcat(sTempTheme,"current.j3d");
    sTempTheme[strlen(sTempTheme)]='\0';
    CreateTheme(sTempTheme);
    sTheme = gtk_combo_box_get_active_text (GTK_COMBO_BOX (XmlOption.ComboTheme));
    strcpy(TmpTheme,j3denv->__sTheme__);
    TmpTheme[strlen(j3denv->__sTheme__)]='\0';

    strcat(TmpTheme,sTheme);
    TmpTheme[strlen(TmpTheme)]='\0';

    ReadTheme (TmpTheme);
    strcpy(j3denv->__sCurrentTheme__,TmpTheme);
    j3denv->__sCurrentTheme__[strlen(TmpTheme)]='\0';
        #ifdef DEBUG
            g_print("LOG-OptionLib.c::CollectData: Default Theme: %s \n",sTempTheme);
            g_print("LOG-OptionLib.c::CollectData: Loading Theme: %s \n",TmpTheme);
            g_print("LOG-Callback.c:OnLoadESP: Current theme-> %s\n",j3denv->__sCurrentTheme__);
        #endif*/
    g_free(sLabelA);
    /*g_free(sLabelB);*/
    g_free(sAnimA);
    /*g_free(sAnimB);*/
return;
}
void
ApplySettings(GtkWidget *widget,gpointer   data)
{
    CollectData();

	if (OglScene->__alive__)
	{
		ReConfigureText();
	}

	return;
}
