/*
 * Jukebox3D / esp Engine
 *
 * Copyright (C) 2005, 2007 Sylvain Pasquet (Sylvain.pasquet@gmail.com - pasquet.sylvain2@wanadoo.fr)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
/*************************************************
 *            callbacks.c						 *
 *************************************************/
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <glade/glade-xml.h>
#include <gtk/gtk.h>
#include <GL/gl.h>
#include <GL/glu.h>

#include "../include/main.h"
#include "../include/LibOgl.h"
#include "../include/LibStr.h"
#include "../include/language.h"
#include "../include/managecfg.h"
#include "../include/interface_ogl.h"
#include "../include/interface_options.h"

void OnQuitInterface(GtkWidget *pWidget, gpointer pData)
{
	/** Arret de la boucle evenementielle **/
	#ifdef DEBUG_CLLBCKS
        g_print("LOG-Callback.c: Jukebox3D stop\n");
	#endif
	signal(SIGALRM, SIG_DFL);
	CreateConfig(j3denv->__sHOME__);
	gtk_main_quit();
	
	
}
void OnOption(GtkWidget *pBtn, gpointer data)
{
	Xml_Opt_load(j3denv->__sGladeOpt__,"window1");
 	gtk_widget_show (XmlOption.window);
}
void OnAboutBtn(GtkWidget *pBtn, gpointer data)
{
    GtkWidget *pAbout;
    gchar sSite[32] = "http://j3d.linuxonfire.org";

    /* Creation de la boite de message */
    /* Type : Information -> GTK_MESSAGE_INFO */
    /* Bouton : 1 OK -> GTK_BUTTONS_OK */
    pAbout = gtk_message_dialog_new (GTK_WINDOW(data),
        GTK_DIALOG_MODAL,
        GTK_MESSAGE_INFO,
        GTK_BUTTONS_OK,
        ESPVERSION,
        sSite);

    /* Affichage de la boite de message */
    gtk_dialog_run(GTK_DIALOG(pAbout));

    /* Destruction de la boite de message */
    gtk_widget_destroy(pAbout);
	return;
}

void OnStartGL(GtkWidget *pBtn, gpointer data)
{

	GtkWidget *window1;
    /*int iAmarokState=0;*/
    /*LoadAmarokInfo("dcop.txt");*/
    /*LoadCoverImg();*/

    if( OglScene->__alive__ == TRUE)
    {
        /*WarningBoxFR("You can't start more than 1 !.\n");*/
        return;
    }

	window1 = StartOGL();
	if (window1 != NULL)
	{
 		gtk_widget_show (window1);
		}else{
        /*WarningBoxFR((char*)TTF_ERROR);*/
    }
	return;
}

void OnSelectTheme(GtkWidget *pWidget,gpointer Widget)
{
    char sTempTheme[128];


    strcpy(sTempTheme,j3denv->__sTheme__);
    sTempTheme[strlen(j3denv->__sTheme__)]='\0';
    strcat(sTempTheme,gtk_combo_box_get_active_text (GTK_COMBO_BOX (XmlOption.ComboTheme)));
    sTempTheme[strlen(sTempTheme)]='\0';
    ReadTheme(sTempTheme);
    #ifdef DEBUG_CLLBCKS
        g_print("LOG-Callback.c::OnSelectTheme \n");
        g_print("LOG-Callback.c::main: Selected theme -> %s\n",sTempTheme);
        g_print("LOG-Callback.c::main: Current Theme -> %s\n",j3denv->__sCurrentTheme__);
    #endif
    if (strcmp(sTempTheme,j3denv->__sCurrentTheme__)!=0)
    {
        strcpy(j3denv->__sCurrentTheme__,sTempTheme);
        j3denv->__sCurrentTheme__[strlen(sTempTheme)]='\0';
        ConfigureOpt();
    }

    if (OglScene->__alive__==1)
    {
        ReConfigureText();
    }

}
void OnSelectTb(GtkWidget *pWidget,gpointer Widget)
{
    char sTempSkin[128];


    strcpy(sTempSkin,j3denv->__sTbSkin__);
    sTempSkin[strlen(j3denv->__sTbSkin__)]='\0';
    strcat(sTempSkin,gtk_combo_box_get_active_text (GTK_COMBO_BOX (XmlOption.combobox3)));
	if( OglScene->__alive__ == TRUE)
    {
    	LdToolbar(sTempSkin);
	}
    if (strcmp(sTempSkin,j3denv->__sTbCurSkin__)!=0)
    {
        strcpy(j3denv->__sTbCurSkin__,sTempSkin);
        j3denv->__sTbCurSkin__[strlen(sTempSkin)]='\0';
        /*ConfigureOpt();*/
    }
    #ifdef DEBUG_CLLBCKS
        g_print("LOG-Callback.c::OnSelectSkin \n");
        g_print("LOG-Callback.c::main: Selected Skin -> %s\n",sTempSkin);
        g_print("LOG-Callback.c::main: Current Theme -> %s\n",j3denv->__sTbCurSkin__);
    #endif
}

void OnSaveTheme(GtkWidget *pWidget,gpointer Widget)
{
    CreateTheme(j3denv->__sCurrentTheme__);
    #ifdef DEBUG_CLLBCKS
        g_print("LOG-Callback.c::main: OverwritingCurrent Theme -> %s\n",j3denv->__sCurrentTheme__);
    #endif
}
void OnSaveEsp(GtkWidget *pWidget,gpointer Widget)
{
    /*FileSelection*/
    GtkWidget *pFileSelection;
    GtkWidget *pParent;
	GtkFileFilter *filter;

	char *LocalPath;
    /*GError    *error=NULL;
    gboolean result;*/

    pParent = GTK_WIDGET(NULL);

    /** Creation de la fenetre de selection */
    pFileSelection = gtk_file_chooser_dialog_new(SAVETHEME,
	GTK_WINDOW(pParent),
	GTK_FILE_CHOOSER_ACTION_SAVE,
	GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
	GTK_STOCK_SAVE, GTK_RESPONSE_OK,
	NULL);
    /* application d'un filtre */
    filter = gtk_file_filter_new ();
	gtk_file_filter_add_pattern (filter, "*.j3d");
    gtk_file_chooser_set_filter(GTK_FILE_CHOOSER(pFileSelection),filter);
    gtk_file_chooser_set_do_overwrite_confirmation(GTK_FILE_CHOOSER(pFileSelection),TRUE);
    /* On limite les actions a cette fenetre */
    gtk_window_set_modal(GTK_WINDOW(pFileSelection), TRUE);
    gtk_file_chooser_set_current_folder (GTK_FILE_CHOOSER (pFileSelection), g_get_home_dir());
    /* Affichage fenetre */
    switch(gtk_dialog_run(GTK_DIALOG(pFileSelection)))
    {
        case GTK_RESPONSE_OK:
            /* Recuperation du chemin */
            LocalPath = gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(pFileSelection));
            #ifdef DEBUG_CLLBCKS
                g_print ("LOG-Callback.c: %s\n",g_strdup_printf("Nom du fichier: %s",(char*)LocalPath));
            #endif
            CreateTheme( (char*)LocalPath );
            break;
        default:
            break;
	}
gtk_widget_destroy(pFileSelection);
}

void OnLoadEsp(GtkWidget *pWidget,gpointer Widget)
{
    /*FileSelection*/
    GtkWidget *pFileSelection;
    GtkWidget *pParent;
	GtkFileFilter *filter;
    char *LocalPath=NULL;
    char *TmpPath=NULL;
    char *FinalTmpPath=NULL;


    TmpPath=malloc(sizeof(char)*128);
    FinalTmpPath=malloc(sizeof(char)*128);

    /*GError    *error=NULL;
    gboolean result;*/

    pParent = GTK_WIDGET(NULL);

    /** Creation de la fenetre de selection */
    pFileSelection = gtk_file_chooser_dialog_new(LOADTHEME,
	GTK_WINDOW(pParent),
	GTK_FILE_CHOOSER_ACTION_OPEN,
	GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL,
	GTK_STOCK_OPEN, GTK_RESPONSE_OK,
	NULL);
	    /* application d'un filtre */
    filter = gtk_file_filter_new ();
	gtk_file_filter_add_pattern (filter, "*.j3d");
    gtk_file_chooser_set_filter(GTK_FILE_CHOOSER(pFileSelection),filter);
    /* On limite les actions a cette fenetre */
    gtk_window_set_modal(GTK_WINDOW(pFileSelection), TRUE);
    gtk_file_chooser_set_current_folder (GTK_FILE_CHOOSER (pFileSelection), g_get_home_dir());
    /* Affichage fenetre */
    switch(gtk_dialog_run(GTK_DIALOG(pFileSelection)))
    {
        case GTK_RESPONSE_OK:
            /* Recuperation du chemin */
            LocalPath = gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(pFileSelection));


            /**Refaire la partie qui recopie dans theme/ **/
            GetFileName(LocalPath,(char*)TmpPath);
            /*ResultCfg=ReadTheme( (char*)LocalPath );*/

            strcpy(FinalTmpPath,j3denv->__sTheme__);
            FinalTmpPath[strlen(j3denv->__sTheme__)]='\0';
            strcat(FinalTmpPath,TmpPath);
            FinalTmpPath[strlen(FinalTmpPath)]='\0';

            ReadTheme( LocalPath );
            CreateTheme(FinalTmpPath);

            strcpy(j3denv->__sCurrentTheme__,FinalTmpPath);
            j3denv->__sCurrentTheme__[strlen(FinalTmpPath)]='\0';
            ConfigureOpt();
            if (OglScene->__alive__)
            {
				#ifdef DEBUG_CLLBCKS
					g_print ("LOG-Callback.c::OnLoadEsp: Reconfigure text triggered\n");
				#endif
                ReConfigureText();
            }
            #ifdef DEBUG_CLLBCKS
                g_print ("LOG-Callback.c::OnLoadEsp: File selected -> %s\n",LocalPath);
                g_print ("LOG-Callback.c::OnLoadEsp: Extracted filename -> %s\n",TmpPath);
                g_print ("LOG-Callback.c::OnLoadEsp: Imported theme -> %s\n",FinalTmpPath);
            #endif
            break;

        default:
            break;
    }
    gtk_widget_destroy(pFileSelection);
    free(TmpPath);
    free(FinalTmpPath);
}
