/*
 * Jukebox3D / esp Engine v2
 *
 * Copyright (C) 2005, 2007 Sylvain Pasquet (Sylvain.pasquet@gmail.com - pasquet.sylvain2@wanadoo.fr)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
/*************************************************
 *            interface_options.c   			 *
 *************************************************/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <glade/glade-xml.h>
#include <gtk/gtk.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <dirent.h>

#include "../include/main.h"
#include "../include/language.h"
#include "../include/LibOptions.h"
#include "../include/interface_main.h"
#include "../include/interface_options.h"

Options XmlOption;
GladeXML *gui_option_xml=NULL;

void
ConfigureOpt (void)
{
	DIR              *dip,*dip2,*dip3;
	struct dirent    *dit, *dit2,*dit3;
	/*GtkTreeModel     *model;*/
	/*GtkCellRenderer  *renderer;*/
	char 			 sTemp[512];
    int              iMyFontIndex=0;
    int              iMyThemeIndex=0;
    int              iMySkinIndex=0;
    int              iTmp=0;
	/**Couleur et style de la fenetre**/
	GdkColor Color = {0, 0xffff, 0xffff, 0xffff};
	char    sTmpTheme[128];
	char    sTmpSkin[128];
	GtkStyle *windowstyle;
	GtkStyle *notebookstyle;
	char     tmpfontsponsors[128];
	
	int iTmpSpon=0;
    /*Combobox*/
    GtkListStore   *ComboFormeA=NULL;
    GtkTreeIter    IndexFormeA;

    GtkListStore   *ComboAnimA=NULL;
    GtkTreeIter    IndexAnimA;

    GtkListStore   *ComboTheme=NULL;
    GtkTreeIter    IndexTheme;

    GtkListStore   *ComboSkin=NULL;
	
    GtkTreeIter    IndexSkin;

    GtkListStore   *ComboPlayer=NULL;
    GtkTreeIter    IndexPlayer;

    GtkListStore   *ComboFonts=NULL;
    GtkTreeIter    IndexFonts;

	/**Modification du style de la fenetre**/
	windowstyle = gtk_style_copy (gtk_widget_get_style (XmlOption.window));
	windowstyle->bg[GTK_STATE_NORMAL] = Color;
	gtk_widget_set_style(XmlOption.window,windowstyle);
	/*Configuration du style du notebook**/
	notebookstyle = gtk_style_copy (gtk_widget_get_style (XmlOption.notebook1));
	notebookstyle->bg[GTK_STATE_NORMAL] = Color;
	gtk_widget_set_style(XmlOption.notebook1,notebookstyle);

    #ifdef DEBUG
        printf("LOG-options.c::ConfigureOpt: Loading and configure Options\n");
        printf("LOG-options.c::ConfigureOpt: Restoring world color\n");
    #endif
    GdkColor ColWorld;
    GdkColor ColBkg;

    /*ColWorld = (GdkColor *)malloc(sizeof(GdkColor));*/
    ColWorld.red   = (OglScene->__aWorldColor__[0]*255) * (65535/255);
    ColWorld.green = (OglScene->__aWorldColor__[1]*255) * (65535/255);
    ColWorld.blue  = (OglScene->__aWorldColor__[2]*255) * (65535/255);

    /* the pixel value indicates the index in the colormap of the color.
    * it is simply a combination of the RGB values we set earlier
    */
    ColWorld.pixel = (gulong)(OglScene->__aWorldColor__[0]*65536 + OglScene->__aWorldColor__[1]*256 + OglScene->__aWorldColor__[2]);
    gtk_color_button_set_color(GTK_COLOR_BUTTON(XmlOption.ColWorld),&ColWorld);
	#ifdef DEBUG
        printf("LOG-options.c::ConfigureOpt: Restoring toolbar skin settings, loading %s\n",j3denv->__sTbSkin__);
    #endif
    ComboSkin = gtk_list_store_new (2,G_TYPE_STRING, G_TYPE_INT);
	/*renderer = gtk_cell_renderer_text_new ();*/
	gtk_combo_box_set_model (GTK_COMBO_BOX (XmlOption.combobox3), GTK_TREE_MODEL (ComboSkin));
	/*gtk_cell_layout_pack_start (GTK_CELL_LAYOUT(GTK_COMBO_BOX (XmlOption.combobox3)), renderer, TRUE);
	gtk_cell_layout_set_attributes (GTK_CELL_LAYOUT(GTK_COMBO_BOX (XmlOption.combobox3)), renderer, "text", 0, NULL);*/

        if ((dip3 = opendir(j3denv->__sTbSkin__)) == NULL)
        {
                perror("opendir");
                return;
        }
        iTmp=0;
        while ((dit3 = readdir(dip3)) != NULL)
        {
            if ((strcmp(dit3->d_name, ".") != 0) && (strcmp(dit3->d_name, "..") != 0))
            {
                gtk_list_store_append (ComboSkin, &IndexSkin);

                gtk_list_store_set (
                ComboSkin, &IndexSkin,
                1,iTmp,0,dit3->d_name,
                -1);

                strcpy(sTmpSkin,j3denv->__sTbSkin__);
                sTmpSkin[strlen(j3denv->__sTbSkin__)]='\0';
                strcat(sTmpSkin,dit3->d_name);
                sTmpSkin[strlen(sTmpSkin)]='\0';

                #ifdef DEBUG
                    printf("LOG-options.c::ConfigureOpt: Add Skin -> %s \n",dit3->d_name);
                    printf("LOG-options.c::ConfigureOpt: Skin index -> %i \n",iTmp);
                    printf("LOG-options.c::ConfigureOpt: Full path -> %s \n", sTmpSkin);
                #endif
                if (strcmp(j3denv->__sTbCurSkin__, sTmpSkin) == 0)
                {
                    iMySkinIndex=iTmp;
                    #ifdef DEBUG
                        printf("LOG-options.c::ConfigureOpt: Current Theme index : %s :: %i\n",dit3->d_name,iMySkinIndex);
                        printf("LOG-options.c::ConfigureOpt: Current Theme -> %s \n",j3denv->__sCurrentTheme__);
                    #endif
                }
                iTmp=iTmp+1;
            }
        }
	
        gtk_combo_box_set_active(GTK_COMBO_BOX(XmlOption.combobox3), iMySkinIndex);

        /* int closedir(DIR *dir);
         *
         * Close the stream to argv[1]. And check for errors. */
        if (closedir(dip3) == -1)
        {
                perror("closedir");
                /*return;*/
        }




    #ifdef DEBUG
        printf("LOG-options.c::ConfigureOpt: Restoring theme settings\n");
    #endif
    /**Restore theme settings**/
    ComboTheme = gtk_list_store_new (2,G_TYPE_STRING, G_TYPE_INT);
	/*renderer = gtk_cell_renderer_text_new ();*/
	/*Skinrenderer = gtk_cell_renderer_text_new ();*/
	gtk_combo_box_set_model (GTK_COMBO_BOX (XmlOption.ComboTheme), GTK_TREE_MODEL (ComboTheme));
	/*gtk_cell_layout_pack_start (GTK_CELL_LAYOUT(GTK_COMBO_BOX (XmlOption.ComboTheme)), renderer, TRUE);
	gtk_cell_layout_set_attributes (GTK_CELL_LAYOUT(GTK_COMBO_BOX (XmlOption.ComboTheme)), renderer, "text", 0, NULL);*/
	
        if ((dip2 = opendir(j3denv->__sTheme__)) == NULL)
        {
                perror("opendir");
                return;
        }

        /*  struct dirent *readdir(DIR *dir);
         *
         * Read in the files and print */

        iTmp=0;
        while ((dit2 = readdir(dip2)) != NULL)
        {
            if ((strcmp(dit2->d_name, ".") != 0) && (strcmp(dit2->d_name, "..") != 0) && (strcmp(dit2->d_name, "TbSkins") != 0))
            {
                /*gtk_combo_box_prepend_text(GTK_COMBO_BOX(XmlOption.ComboTheme), dit2->d_name);*/
                gtk_list_store_append (ComboTheme, &IndexTheme);

                gtk_list_store_set (
                ComboTheme, &IndexTheme,
                1,iTmp,0,dit2->d_name,
                -1);

                strcpy(sTmpTheme,j3denv->__sTheme__);
                sTmpTheme[strlen(sTmpTheme)]='\0';
                strcat(sTmpTheme,dit2->d_name);
                sTmpTheme[strlen(sTmpTheme)]='\0';

                #ifdef DEBUG
                    printf("LOG-options.c::ConfigureOpt: Add Theme -> %s \n",dit2->d_name);
                    printf("LOG-options.c::ConfigureOpt: Theme index -> %i \n",iTmp);
                    printf("LOG-options.c::ConfigureOpt: Full path -> %s \n", sTmpTheme);
                #endif
                if (strcmp(j3denv->__sCurrentTheme__, sTmpTheme) == 0)
                {
                    iMyThemeIndex=iTmp;
                    #ifdef DEBUG
                        printf("LOG-options.c::ConfigureOpt: Current Theme index : %s :: %i\n",dit2->d_name,iMyThemeIndex);
                        printf("LOG-options.c::ConfigureOpt: Current Theme -> %s \n",j3denv->__sCurrentTheme__);
                    #endif
                }
                iTmp=iTmp+1;
            }
        }

       
        gtk_combo_box_set_active(GTK_COMBO_BOX(XmlOption.ComboTheme), iMyThemeIndex);

        /* int closedir(DIR *dir);
         *
         * Close the stream to argv[1]. And check for errors. */
        if (closedir(dip2) == -1)
        {
                perror("closedir");
                return;
        }

    #ifdef DEBUG
        printf("LOG-options.c::ConfigureOpt: Initialize Form and animation combo box\n");
    #endif

    ComboFormeA = gtk_list_store_new (2,G_TYPE_STRING, G_TYPE_INT);

    gtk_list_store_append (ComboFormeA, &IndexFormeA);

    gtk_list_store_set (
    ComboFormeA, &IndexFormeA,
    1,0,0,RECTANGLE,
    -1);

    gtk_list_store_append (ComboFormeA, &IndexFormeA);
    gtk_list_store_set (
    ComboFormeA, &IndexFormeA,
    1,1,0,PLAT,
    -1);

    gtk_list_store_append (ComboFormeA, &IndexFormeA);
    gtk_list_store_set (
    ComboFormeA, &IndexFormeA,
    1,2,0,CUBE,
    -1);

    gtk_list_store_append (ComboFormeA, &IndexFormeA);
    gtk_list_store_set (
    ComboFormeA, &IndexFormeA,
    1,3,0,DRAPEAU,
    -1);

    gtk_list_store_append (ComboFormeA, &IndexFormeA);
    gtk_list_store_set (
    ComboFormeA, &IndexFormeA,
    1,4,0,CDBOX,
    -1);


    gtk_list_store_append (ComboFormeA, &IndexFormeA);
    gtk_list_store_set (
    ComboFormeA, &IndexFormeA,
    1,4,0,RIEN,
    -1);

    gtk_combo_box_set_model (GTK_COMBO_BOX (XmlOption.ComboFormeA), GTK_TREE_MODEL (ComboFormeA));
    ComboPlayer = gtk_list_store_new (2,G_TYPE_STRING, G_TYPE_INT);

    gtk_list_store_append (ComboPlayer, &IndexPlayer);

    gtk_list_store_set (
    ComboPlayer, &IndexPlayer,
    1,0,0,AMAROK,
    -1);

    gtk_list_store_append (ComboPlayer, &IndexPlayer);
    gtk_list_store_set (
    ComboPlayer, &IndexPlayer,
    1,1,0,RHYTHMBOX,
    -1);
    gtk_list_store_append (ComboPlayer, &IndexPlayer);
    gtk_list_store_set (
    ComboPlayer, &IndexPlayer,
    1,2,0,EXAILE,
    -1);
    gtk_list_store_append (ComboPlayer, &IndexPlayer);
    gtk_list_store_set (
    ComboPlayer, &IndexPlayer,
    1,3,0,MPD,
    -1);
    gtk_combo_box_set_model (GTK_COMBO_BOX (XmlOption.ComboPlayer), GTK_TREE_MODEL (ComboPlayer));
    gtk_combo_box_set_active (GTK_COMBO_BOX (XmlOption.ComboPlayer), 0);

	strcpy(sTemp,j3denv->__sDataPath__);
	strcat(sTemp,"scripts/amarok");
    if (strcmp(j3denv->__sCurrentScript__,sTemp)==0)
    {
        gtk_combo_box_set_active (GTK_COMBO_BOX (XmlOption.ComboPlayer), 0);
        #ifdef DEBUG
                printf("LOG-options.c::ConfigureOpt: OglScene->__iScript__ -> %s\n",j3denv->__sCurrentScript__);
        #endif

    }
	strcpy(sTemp,j3denv->__sDataPath__);
	strcat(sTemp,"scripts/rhythmbox");
    if (strcmp(j3denv->__sCurrentScript__,sTemp)==0)
    {

        gtk_combo_box_set_active (GTK_COMBO_BOX (XmlOption.ComboPlayer), 1);
        #ifdef DEBUG
                printf("LOG-options.c::ConfigureOpt: OglScene->__iScript__ -> %s\n",j3denv->__sCurrentScript__);
        #endif
    }
	strcpy(sTemp,j3denv->__sDataPath__);
	strcat(sTemp,"scripts/exaile");
    if (strcmp(j3denv->__sCurrentScript__,sTemp)==0)
    {
        gtk_combo_box_set_active (GTK_COMBO_BOX (XmlOption.ComboPlayer), 2);
        #ifdef DEBUG
                printf("LOG-options.c::ConfigureOpt: OglScene->__iScript__ -> %s\n",j3denv->__sCurrentScript__);
        #endif
    }
	strcpy(sTemp,j3denv->__sDataPath__);
	strcat(sTemp,"scripts/mpc");
    if (strcmp(j3denv->__sCurrentScript__,sTemp)==0)
    {
        gtk_combo_box_set_active (GTK_COMBO_BOX (XmlOption.ComboPlayer), 3);
        #ifdef DEBUG
                printf("LOG-options.c::ConfigureOpt: OglScene->__iScript__ -> %s\n",j3denv->__sCurrentScript__);
        #endif
    }
    /*gtk_combo_box_set_active (GTK_COMBO_BOX (XmlOption.ComboFormeA), 0);*/
    #ifdef DEBUG
            printf("LOG-options.c::ConfigureOpt: OglScene->__styleA__ -> %i\n",OglScene->__model__);
    #endif
    switch(OglScene->__model__)
        {
            case 0:
                gtk_combo_box_set_active (GTK_COMBO_BOX (XmlOption.ComboFormeA), 2);
                break;
            case 1:
                gtk_combo_box_set_active (GTK_COMBO_BOX (XmlOption.ComboFormeA), 0);
                break;
            case 2:
                gtk_combo_box_set_active (GTK_COMBO_BOX (XmlOption.ComboFormeA), 1);
                break;
            case 3:
                gtk_combo_box_set_active (GTK_COMBO_BOX (XmlOption.ComboFormeA), 3);
                break;
            case 4:
                #ifdef DEBUG
                    printf("LOG-options.c::ConfigureOpt: comboformeA -> nothing\n");
                #endif
                gtk_combo_box_set_active (GTK_COMBO_BOX (XmlOption.ComboFormeA), 5);
                break;
            case 5:
                gtk_combo_box_set_active (GTK_COMBO_BOX (XmlOption.ComboFormeA), 4);
                break;
            default:
                printf("erreur eSportscene.style\n");
        }

    gtk_range_set_value(GTK_RANGE(XmlOption.hscale2), OglScene->__fCurPlaySize__*10.0);
    gtk_range_set_value(GTK_RANGE(XmlOption.slide1),  OglScene->__speed__*100);

    gtk_range_set_value(GTK_RANGE(XmlOption.hscale3), OglScene->__fArchiveSize__*10.0);

    /*********************/
    /**Background Object**/
    /*********************/
    gtk_range_set_value(GTK_RANGE(XmlOption.hscale4), OglObject[1].fWidth*10.0);
    gtk_range_set_value(GTK_RANGE(XmlOption.hscale5), OglObject[1].fHeight*10.0);
    ColBkg.red   = (OglObject[1].red*255) * (65535/255);
    ColBkg.green = (OglObject[1].green*255) * (65535/255);
    ColBkg.blue  = (OglObject[1].blue*255) * (65535/255);

    /* the pixel value indicates the index in the colormap of the color.
    * it is simply a combination of the RGB values we set earlier
    */
    ColBkg.pixel = (gulong)(OglObject[1].red*65536 + OglObject[1].green*256 + OglObject[1].blue);
    gtk_color_button_set_color(GTK_COLOR_BUTTON(XmlOption.colorbutton6),&ColBkg);
    if(OglObject[1].hidden==0)
    {gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(XmlOption.checkbutton5),TRUE);}else
    {gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(XmlOption.checkbutton5),FALSE);}
    if(OglScene->__iAlwaysDispInf__!=1)
    {gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(XmlOption.checkbutton4),TRUE);}else
    {gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(XmlOption.checkbutton4),FALSE);}

    /*********************/
    /*********************/
    #ifdef DEBUG
           /* printf("LOG-options.c::ConfigureOpt: OglScene->__styleB__ -> %i\n",OglScene->__styleB__);*/
    #endif

    if (OglScene->__iArchiveMode__==1)
    {
            gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(XmlOption.checkbutton3),TRUE);
            #ifdef DEBUG
                g_print("LOG-OpitonLib.c::ConfigureOpt: Archive mode is enabled \n");
            #endif
    }else{

            gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(XmlOption.checkbutton3),FALSE);
            #ifdef DEBUG
                g_print("LOG-OpitonLib.c::ConfigureOpt: Archive mode is disabled \n");
            #endif
    }

    if (OglScene->__iActCurPlayRef__==1)
    {
            gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(XmlOption.checkbutton6),TRUE);
            #ifdef DEBUG
                g_print("LOG-OpitonLib.c::ConfigureOpt: Current play reflexion mode is enabled \n");
            #endif
    }else{

            gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(XmlOption.checkbutton6),FALSE);
            #ifdef DEBUG
                g_print("LOG-OpitonLib.c::ConfigureOpt: Current play reflexion mode is disabled \n");
            #endif
    }
    if (OglScene->__iActArchRef__==1)
    {
            gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(XmlOption.checkbutton7),TRUE);
            #ifdef DEBUG
                g_print("LOG-OpitonLib.c::ConfigureOpt: Archive reflexion mode is enabled \n");
            #endif
    }else{

            gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(XmlOption.checkbutton7),FALSE);
            #ifdef DEBUG
                g_print("LOG-OpitonLib.c::ConfigureOpt: Archive reflexion mode is disabled \n");
            #endif
    }


    if (OglScene->__iAlwaysDispInf__!=1)
    {
            gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(XmlOption.checkbutton4),TRUE);
            #ifdef DEBUG
                g_print("LOG-OpitonLib.c::ConfigureOpt: Always displaying information \n");
            #endif
    }else{

            gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(XmlOption.checkbutton4),FALSE);
            #ifdef DEBUG
                g_print("LOG-OpitonLib.c::ConfigureOpt: Disable always displaying information \n");
            #endif
    }
    /*switch(OglScene->__styleB__)
        {
            case 0:
                gtk_combo_box_set_active (GTK_COMBO_BOX (XmlOption.ComboFormeB), 2);
                break;
            case 1:
                gtk_combo_box_set_active (GTK_COMBO_BOX (XmlOption.ComboFormeB), 0);
                break;
            case 2:
                gtk_combo_box_set_active (GTK_COMBO_BOX (XmlOption.ComboFormeB), 1);
                break;
            case 3:
                gtk_combo_box_set_active (GTK_COMBO_BOX (XmlOption.ComboFormeB), 3);
                break;
            case 4:
                #ifdef DEBUG
                    printf("LOG-options.c::ConfigureOpt: comboformeB -> nothing\n");
                #endif
                gtk_combo_box_set_active (GTK_COMBO_BOX (XmlOption.ComboFormeB), 4);
                break;
            default:
                printf("erreur eSportscene.style\n");
        }*/


    ComboAnimA = gtk_list_store_new (2,G_TYPE_STRING, G_TYPE_INT);
    /* Ajout d'un nouvel element dans le magasin. */
    gtk_list_store_append (ComboAnimA, &IndexAnimA);

    gtk_list_store_set (
    ComboAnimA, &IndexAnimA,
    1,0,0,R360H1,
    -1);
    gtk_list_store_append (ComboAnimA, &IndexAnimA);
    gtk_list_store_set (
    ComboAnimA, &IndexAnimA,
    1,1,0,R360H2,
    -1);
    gtk_list_store_append (ComboAnimA, &IndexAnimA);
     gtk_list_store_set (
    ComboAnimA, &IndexAnimA,
    1,2,0,R360V1,
    -1);
    gtk_list_store_append (ComboAnimA, &IndexAnimA);
    gtk_list_store_set (
    ComboAnimA, &IndexAnimA,
    1,3,0,R360V2,
    -1);
    gtk_list_store_append (ComboAnimA, &IndexAnimA);
    gtk_list_store_set (
    ComboAnimA, &IndexAnimA,
    1,4,0,RNOROT,
    -1);
    gtk_combo_box_set_model (GTK_COMBO_BOX (XmlOption.ComboAnimA), GTK_TREE_MODEL (ComboAnimA));
    /*
     * On affiche un element par defaut. L'index commence à zero.
     */
    switch(OglScene->__style_anim__)
        {
            case 0:
                gtk_combo_box_set_active (GTK_COMBO_BOX (XmlOption.ComboAnimA), 0);
                break;
            case 1:
                gtk_combo_box_set_active (GTK_COMBO_BOX (XmlOption.ComboAnimA), 1);
                break;
            case 2:
                gtk_combo_box_set_active (GTK_COMBO_BOX (XmlOption.ComboAnimA), 2);
                break;
            case 3:
                gtk_combo_box_set_active (GTK_COMBO_BOX (XmlOption.ComboAnimA), 3);
                break;
            case 4:
                gtk_combo_box_set_active (GTK_COMBO_BOX (XmlOption.ComboAnimA), 4);
                break;
            default:
                printf("erreur eSportscene.style\n");
        }



    /*gtk_combo_box_set_model (GTK_COMBO_BOX (XmlOption.ComboAnimB), GTK_TREE_MODEL (ComboAnimA));*/
    /*
     * On affiche un element par defaut. L'index commence à zero.
     */
   /* switch(OglScene->__style_animB__)
        {
            case 0:
                gtk_combo_box_set_active (GTK_COMBO_BOX (XmlOption.ComboAnimB), 0);
                break;
            case 1:
                gtk_combo_box_set_active (GTK_COMBO_BOX (XmlOption.ComboAnimB), 1);
                break;
            case 2:
                gtk_combo_box_set_active (GTK_COMBO_BOX (XmlOption.ComboAnimB), 2);
                break;
            case 3:
                gtk_combo_box_set_active (GTK_COMBO_BOX (XmlOption.ComboAnimB), 3);
                break;
            case 4:
                gtk_combo_box_set_active (GTK_COMBO_BOX (XmlOption.ComboAnimB), 4);
                break;
            default:
                printf("erreur eSportscene.style\n");
        }*/

/*gtk_combo_box_prepend_text(GTK_COMBO_BOX(XmlOption.ComboAnimA), "360 Sens H1");*/



    /**Sponsors**/
	/*renderer = gtk_cell_renderer_text_new ();
	gtk_tree_view_insert_column_with_attributes (GTK_TREE_VIEW(XmlOption.treeview1),
                                               -1,
                                               "Label",
                                               renderer,
                                               "text", 0,
                                               NULL);

	renderer = gtk_cell_renderer_text_new ();
	gtk_tree_view_insert_column_with_attributes (GTK_TREE_VIEW(XmlOption.treeview1),
                                               -1,
                                               "Type",
                                               renderer,
                                               "text", 1,
                                               NULL);

		CreateTreeView();
		model=GTK_TREE_MODEL (store);
	gtk_tree_view_set_model (GTK_TREE_VIEW(XmlOption.treeview1), model);*/

  /* The tree view has acquired its own reference to the
   *  model, so we can drop ours. That way the model will
   *  be freed automatically when the tree view is destroyed */
  	/*g_object_unref (model);*/


	strcpy(tmpfontsponsors,j3denv->__sDataPath__);
    tmpfontsponsors[strlen(tmpfontsponsors)]='\0';
	strcat(tmpfontsponsors,"fonts/");
    tmpfontsponsors[strlen(tmpfontsponsors)]='\0';
    ComboFonts= gtk_list_store_new (2,G_TYPE_STRING, G_TYPE_INT);
        if ((dip = opendir(tmpfontsponsors)) == NULL)
        {
                perror("opendir");
                return;
        }

        /*  struct dirent *readdir(DIR *dir);
         *
         * Read in the files and print */

        iTmp=0;
        while ((dit = readdir(dip)) != NULL)
        {
            if ((strcmp(dit->d_name, ".") != 0) && (strcmp(dit->d_name, "..") != 0))
            {
                /*gtk_combo_box_prepend_text(GTK_COMBO_BOX(XmlOption.combobox1), dit->d_name);*/
                gtk_list_store_append (ComboFonts, &IndexFonts);

                gtk_list_store_set (
                ComboFonts, &IndexFonts,
                1,iTmp,0,dit->d_name,
                -1);
                #ifdef DEBUG
                    printf("LOG-options.c::ConfigureOpt: Add fonts -> %s \n",dit->d_name);
                    printf("LOG-options.c::ConfigureOpt: Font index -> %i \n",iTmp);
                #endif
                if (strcmp(font_struct->cFontPath, dit->d_name) == 0)
                {
                    iMyFontIndex=iTmp;
                #ifdef DEBUG
                    printf("LOG-options.c::ConfigureOpt: Current font index : %s :: %i\n",dit->d_name,iMyFontIndex);
                    printf("LOG-options.c::ConfigureOpt: font_sponsors.cFontPath -> %s \n",font_sponsors.cFontPath);
                #endif
                }
                iTmp=iTmp+1;
            }




        }

        gtk_combo_box_set_model (GTK_COMBO_BOX (XmlOption.combobox1), GTK_TREE_MODEL (ComboFonts));
        gtk_combo_box_set_active(GTK_COMBO_BOX(XmlOption.combobox1), iMyFontIndex);
        #ifdef DEBUG
            printf("LOG-options.c::ConfigureOpt: iMyFontIndex -> %i \n",iMyFontIndex);
            printf("LOG-options.c::ConfigureOpt: iTmp -> %i\n",iTmp);
        #endif

        /* int closedir(DIR *dir);
         *
         * Close the stream to argv[1]. And check for errors. */
        if (closedir(dip) == -1)
        {
                perror("closedir");
                return;
        }


	/** Restore sponsors settings into option GUI    **/
    if (OglScene->__ActSpons__==1)
	{
        #ifdef DEBUG
            printf("LOG-options.c::ConfigureOpt: Loading sponsors settings\n");
        #endif
      /* red, green, and blue are passed values, indicating the RGB triple
       * of the color we want to draw. Note that the values of the RGB components
       * within the GdkColor are taken from 0 to 65535, not 0 to 255.
       */
        GdkColor *PartSpon;
        PartSpon = (GdkColor *)malloc(sizeof(GdkColor));
        PartSpon->red = (font_struct->red*255) * (65535/255);
        PartSpon->green = (font_struct->green*255) * (65535/255);
        PartSpon->blue = (font_struct->blue*255) * (65535/255);

        /* the pixel value indicates the index in the colormap of the color.
        * it is simply a combination of the RGB values we set earlier
        */
        PartSpon->pixel = (gulong)(PartSpon->red*65536 + PartSpon->green*256 + PartSpon->blue);
        gtk_color_button_set_color(GTK_COLOR_BUTTON(XmlOption.ColTexte),PartSpon);

        /*gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(XmlOption.checkbutton1),TRUE);*/
        /*gtk_combo_box_set_active (GTK_COMBO_BOX (XmlOption.combobox1), 1);*/
        /*gtk_widget_set_sensitive(XmlOption.button7,TRUE);
        gtk_widget_set_sensitive(XmlOption.button8,TRUE);*/
        gtk_widget_set_sensitive(XmlOption.button3,TRUE);

		gtk_widget_set_sensitive(XmlOption.button9,TRUE);
        gtk_widget_set_sensitive(XmlOption.button11,TRUE);
		gtk_widget_set_sensitive(XmlOption.button12,TRUE);
        gtk_widget_set_sensitive(XmlOption.spinbutton1,TRUE);
		gtk_widget_set_sensitive(XmlOption.combobox1,TRUE);
        /*gtk_widget_set_sensitive(XmlOption.spinbutton3,TRUE);*/
		gtk_widget_set_sensitive(XmlOption.ColTexte,TRUE);
		gtk_spin_button_set_value(GTK_SPIN_BUTTON(XmlOption.spinbutton1),(double)font_struct->iFontSize);
		gtk_spin_button_set_value(GTK_SPIN_BUTTON(XmlOption.spinbutton2),(double)font_struct->iSpaceLine);
        /*gtk_spin_button_set_value(GTK_SPIN_BUTTON(XmlOption.spinbutton3),(double)OglScene->__fTimeSpons__);*/
		iTmpSpon=1;

        g_free(PartSpon);
        gtk_combo_box_set_active(GTK_COMBO_BOX(XmlOption.combobox1), (int)iMyFontIndex);
	}else
	{

        /*gtk_widget_set_sensitive(XmlOption.button7,FALSE);
        gtk_widget_set_sensitive(XmlOption.button8,FALSE);*/
        gtk_widget_set_sensitive(XmlOption.button3,FALSE);
		gtk_widget_set_sensitive(XmlOption.button9,FALSE);
        gtk_widget_set_sensitive(XmlOption.button11,FALSE);
		gtk_widget_set_sensitive(XmlOption.button12,FALSE);
		gtk_widget_set_sensitive(XmlOption.combobox1,FALSE);
        gtk_widget_set_sensitive(XmlOption.spinbutton1,FALSE);
        /*gtk_widget_set_sensitive(XmlOption.spinbutton3,FALSE);*/
		gtk_widget_set_sensitive(XmlOption.ColTexte,FALSE);
		iTmpSpon=0;
	}
	/**************************************************/


	/** Restore sponsors settings into option GUI    **/
    /*if (OglScene->__AlivPart__==1)
	{
        #ifdef DEBUG
            printf("LOG-options.c::ConfigureOpt: Loading particules settings\n");
        #endif
        gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(XmlOption.ActParti),TRUE);
        gtk_widget_set_sensitive(XmlOption.radiobutton13,TRUE);
        gtk_widget_set_sensitive(XmlOption.radiobutton14,TRUE);
        gtk_widget_set_sensitive(XmlOption.ColTeamA,TRUE);
        gtk_widget_set_sensitive(XmlOption.ColTeamB,TRUE);
        if (OglScene->__iModePart__==1)
        {
            gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(XmlOption.radiobutton14),TRUE);
        }else{
            gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(XmlOption.radiobutton13),TRUE);
        }*/
      /* red, green, and blue are passed values, indicating the RGB triple
       * of the color we want to draw. Note that the values of the RGB components
       * within the GdkColor are taken from 0 to 65535, not 0 to 255.
       */
       /* GdkColor *PartColA;
        GdkColor *PartColB;
        PartColA = (GdkColor *)malloc(sizeof(GdkColor));
        PartColA->red = (__pColPartA__.red*255) * (65535/255);
        PartColA->green = (__pColPartA__.green*255) * (65535/255);
        PartColA->blue = (__pColPartA__.blue*255) * (65535/255);

        PartColB = (GdkColor *)malloc(sizeof(GdkColor));
        PartColB->red = (__pColPartB__.red*255) * (65535/255);
        PartColB->green = (__pColPartB__.green*255) * (65535/255);
        PartColB->blue = (__pColPartB__.blue*255) * (65535/255);
*/
        /* the pixel value indicates the index in the colormap of the color.
        * it is simply a combination of the RGB values we set earlier
        */
       /* PartColA->pixel = (gulong)(PartColA->red*65536 + PartColA->green*256 + PartColA->blue);
        PartColB->pixel = (gulong)(PartColB->red*65536 + PartColB->green*256 + PartColB->blue);
*/
  		#ifdef DEBUG
		/*g_print("ColTeamA PartColA->pixel: %u\n",PartColA->pixel);
		g_print("ColTeamA PartColA->red: %u\n",PartColA->red*65535);
		g_print("ColTeamA PartColA->red 255: %u\n",PartColA->red);
		g_print("ColTeamA PartColA->green: %u\n",PartColA->green*65535);
		g_print("ColTeamA PartColA->green 255: %f\n",PartColA->green);
		g_print("ColTeamA PartColA->blue: %u\n",PartColA->blue*65535);
		g_print("ColTeamA PartColA->blue 255: %f\n",PartColA->blue);
		g_print("ColTeamB Red: %u\n",colorB.red);
		g_print("ColTeamB green: %u\n",colorB.green);
		g_print("ColTeamB blue: %u\n",colorB.blue);*/
		#endif
        /*gtk_color_button_set_color(GTK_COLOR_BUTTON(XmlOption.ColTeamA),PartColA);
        gtk_color_button_set_color(GTK_COLOR_BUTTON(XmlOption.ColTeamB),PartColB);
        g_free(PartColA);
        g_free(PartColB);
        iTmpPart=1;

	}else
	{
	    gtk_widget_set_sensitive(XmlOption.radiobutton13,FALSE);
        gtk_widget_set_sensitive(XmlOption.radiobutton14,FALSE);
        gtk_widget_set_sensitive(XmlOption.ColTeamA,FALSE);
        gtk_widget_set_sensitive(XmlOption.ColTeamB,FALSE);
        iTmpPart=0;
	}*/
	/**************************************************/
    #ifdef DEBUG_OPT
		g_print("LOG-options.c::ConfigureOpt:: Configure Text\n");
    #endif
    /*XmlOption.radiobutton1*/
    switch (font_struct->iTextAlign)
    {
        case 0:
                gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(XmlOption.radiobutton1),TRUE);
            break;

        case 1:
                gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(XmlOption.radiobutton2),TRUE);
            break;

        case 2:
                gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(XmlOption.radiobutton3),TRUE);
            break;
        default:
            gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(XmlOption.radiobutton1),TRUE);
            break;
    }


	/*if (OglScene->__ActFog__==0)
	{
    gtk_widget_set_sensitive(XmlOption.spinbutton2,FALSE);
	}else{
    gtk_widget_set_sensitive(XmlOption.spinbutton2,TRUE);

	}*/


	return;
}
void
Xml_Opt_load (char *path, char *root) {
	gui_option_xml = glade_xml_new(path, root, NULL);
	// test de réussite de chargement
	if( !gui_option_xml ) {
        printf("LOG-options.c::Xml_Opt_load: ERR: Xml.glade loading error\n");
	}
	Xml_widget_load (gui_option_xml, "radiobutton1", &XmlOption.radiobutton1);
	Xml_widget_load (gui_option_xml, "radiobutton2", &XmlOption.radiobutton2);
	Xml_widget_load (gui_option_xml, "radiobutton3", &XmlOption.radiobutton3);
	Xml_widget_load (gui_option_xml, "window1"     , &XmlOption.window);
	Xml_widget_load (gui_option_xml, "notebook1"   , &XmlOption.notebook1);
    Xml_widget_load (gui_option_xml, "ComboFormeA", &XmlOption.ComboFormeA);
    Xml_widget_load (gui_option_xml, "ComboAnimA", &XmlOption.ComboAnimA);
	Xml_widget_load (gui_option_xml, "hscale1"      , &XmlOption.slide1);
    Xml_widget_load (gui_option_xml, "hscale2"      , &XmlOption.hscale2);
    Xml_widget_load (gui_option_xml, "hscale3"      , &XmlOption.hscale3);
    Xml_widget_load (gui_option_xml, "hscale4"      , &XmlOption.hscale4);
    Xml_widget_load (gui_option_xml, "hscale5"      , &XmlOption.hscale5);
    Xml_widget_load (gui_option_xml, "ComboPlayer"  , &XmlOption.ComboPlayer);

	Xml_widget_load (gui_option_xml, "Select_Police", &XmlOption.combobox1);
	Xml_widget_load (gui_option_xml, "combobox1"    , &XmlOption.ComboTheme);
	Xml_widget_load (gui_option_xml, "combobox3"    , &XmlOption.combobox3);
	Xml_widget_load (gui_option_xml, "spinbutton1"  , &XmlOption.spinbutton1);
	Xml_widget_load (gui_option_xml, "spinbutton2"  , &XmlOption.spinbutton2);
	Xml_widget_load (gui_option_xml, "checkbutton3" , &XmlOption.checkbutton3);
	Xml_widget_load (gui_option_xml, "checkbutton4" , &XmlOption.checkbutton4);
	Xml_widget_load (gui_option_xml, "checkbutton5" , &XmlOption.checkbutton5);
	Xml_widget_load (gui_option_xml, "checkbutton6" , &XmlOption.checkbutton6);
	Xml_widget_load (gui_option_xml, "checkbutton7" , &XmlOption.checkbutton7);
	Xml_widget_load (gui_option_xml, "treeview1"    , &XmlOption.treeview1);

	Xml_widget_load (gui_option_xml, "button3"      , &XmlOption.button3);
	Xml_widget_load (gui_option_xml, "button9"      , &XmlOption.button9);
    Xml_widget_load (gui_option_xml, "button11"     , &XmlOption.button11);
	Xml_widget_load (gui_option_xml, "button12"     , &XmlOption.button12);
	Xml_widget_load (gui_option_xml, "colorbutton3" , &XmlOption.ColTexte);
	Xml_widget_load (gui_option_xml, "colorbutton4" , &XmlOption.ColWorld);
	Xml_widget_load (gui_option_xml, "colorbutton6" , &XmlOption.colorbutton6);
	
	ConfigureOpt();

	/* On lie les signaux définis dans Glade à leur fonction de callback */
	glade_xml_signal_autoconnect(gui_option_xml);
	return;
}
void CloseOptEvent(GtkWidget *Widget, gpointer data)
{
	#ifdef DEBUG_OPT
		g_print("LOG-options.c::ConfigureOpt:: CloseOptEvent\n");
    #endif
	gtk_widget_destroy(XmlOption.window);
return;
}
