/*
 * Jukebox3D / esp Engine
 *
 * Copyright (C) 2005, 2007 Sylvain Pasquet (Sylvain.pasquet@gmail.com - pasquet.sylvain2@wanadoo.fr)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <gtk/gtk.h>
#include <gtk/gtkgl.h>
#include <string.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include "../include/interface_ogl.h"
#define PI 3.14

void nPlaneTeam(int num)
{
	glNewList(num,GL_COMPILE);
	glBegin(GL_QUADS);

        glTexCoord2f (0.0f, 1.0f);
        /** lower right corner of image **/
        glVertex2f(-1.0, -1.0);
        glTexCoord2f (1.0f, 1.0f);
        /** lower left corner of image */
        glVertex2f( 1.0, -1.0);

        glTexCoord2f (1.0f, 0.0f);
        /** upper left corner of image */
        glVertex2f( 1.0,  1.0);
        glTexCoord2f (0.0f,0.0f);
        /** upper right corner of image */
        glVertex2f(-1.0,  1.0);

	glEnd();
	glEndList();
	return;
}
void nFxBox(int num)
{

	glNewList(num,GL_COMPILE);
    glBegin(GL_QUADS);

        glTexCoord2f (0.0f, 1.0f);
        glVertex3f(-0.9, -0.9,  0.03);
        glTexCoord2f (1.0f, 1.0f);
        glVertex3f ( 0.9, -0.9,  0.03);
        glTexCoord2f (1.0f, 0.0f);
        glVertex3f( 0.9,  0.9,  0.03);
        glTexCoord2f (0.0f,0.0f);
        glVertex3f(-0.9,  0.9,  0.03);

        /**# Back Face**/

        glTexCoord2f (1.0f, 1.0f);
        glVertex3f(-0.9, -0.9, -0.03);
        glTexCoord2f (1.0f, 0.0f);
        glVertex3f(-0.9,  0.9, -0.03);
        glTexCoord2f (0.0f,0.0f);
        glVertex3f( 0.9,  0.9, -0.03);
        glTexCoord2f (0.0f,1.0f);
        glVertex3f( 0.9, -0.9, -0.03);

    /*	glTexCoord2f (1.0f, 1.0f);
        glVertex3f(-0.9, -0.9, -0.03);
        glTexCoord2f (1.0f, 0.0f);
        glVertex3f(-0.9,  0.9, -0.03);
        glTexCoord2f (0.0f,0.0f);
        glVertex3f( 0.9,  0.9, -0.03);
        glTexCoord2f (0.0f,1.0f);
        glVertex3f( 0.9, -0.9, -0.03);*/

	glEnd();
	glEndList();
	return;

}
void nCdBox(int num)
{

	glNewList(num,GL_COMPILE);
    glBegin(GL_QUADS);

        glTexCoord2f (0.0f, 1.0f);
        glVertex3f(-0.9, -0.9,  0.03);
        glTexCoord2f (1.0f, 1.0f);
        glVertex3f ( 0.9, -0.9,  0.03);
        glTexCoord2f (1.0f, 0.0f);
        glVertex3f( 0.9,  0.9,  0.03);
        glTexCoord2f (0.0f,0.0f);
        glVertex3f(-0.9,  0.9,  0.03);

        /**# Back Face**/

        glTexCoord2f (1.0f, 1.0f);
        glVertex3f(-0.9, -0.9, -0.03);
        glTexCoord2f (1.0f, 0.0f);
        glVertex3f(-0.9,  0.9, -0.03);
        glTexCoord2f (0.0f,0.0f);
        glVertex3f( 0.9,  0.9, -0.03);
        glTexCoord2f (0.0f,1.0f);
        glVertex3f( 0.9, -0.9, -0.03);

    /*	glTexCoord2f (1.0f, 1.0f);
        glVertex3f(-0.9, -0.9, -0.03);
        glTexCoord2f (1.0f, 0.0f);
        glVertex3f(-0.9,  0.9, -0.03);
        glTexCoord2f (0.0f,0.0f);
        glVertex3f( 0.9,  0.9, -0.03);
        glTexCoord2f (0.0f,1.0f);
        glVertex3f( 0.9, -0.9, -0.03);*/

	glEnd();
    glDisable (GL_TEXTURE_2D);
    glColor3f(0.2,0.2,0.2);
	glBegin(GL_QUADS);
	/**# Top Face**/
	glVertex3f(-0.9,  0.9, -0.03);
	glVertex3f(-0.9,  0.9,  0.03);
	glVertex3f( 0.9,  0.9,  0.03);
	glVertex3f( 0.9,  0.9, -0.03);
		/** # Bottom Face**/
	glVertex3f(-0.9, -0.9, -0.03);
	glVertex3f( 0.9, -0.9, -0.03);
	glVertex3f( 0.9, -0.9,  0.03);
	glVertex3f(-0.9, -0.9,  0.03);
	/**# Right face**/
	glVertex3f( 0.9, -0.9, -0.03);
	glVertex3f( 0.9,  0.9, -0.03);
	glVertex3f( 0.9,  0.9,  0.03);
	glVertex3f( 0.9, -0.9,  0.03);
    /**# Left Face**/
	glVertex3f(-0.9, -0.9, -0.03);
	glVertex3f(-0.9, -0.9,  0.03);
	glVertex3f(-0.9,  0.9,  0.03);
	glVertex3f(-0.9,  0.9, -0.03);
	glEnd();
    glEnable (GL_TEXTURE_2D);
	glEndList();
	return;

}

void nSphere(int a,int b,int num) {

float da = ( PI / a );
float db = ( 2.0f * PI / b );
int i=0;
int j=0;

glNewList(num,GL_COMPILE);
glBegin(GL_QUADS);
glColor3f(1.0,1.0,1.0);
glNormal3f(0,0,1);
for( i = 0; i < a + 1 ; i++ ) {
 float r0 = sin ( i * da );
 float y0 = cos ( i * da );
 float r1 = sin ( (i+1) * da );
 float y1 = cos ( (i+1) * da );

 for( j = 0; j < b + 1 ; j++ ) {
  float x0 = r0 * sin( j * db );
  float z0 = r0 * cos( j * db );
  float x1 = r0 * sin( (j+1) * db );
  float z1 = r0 * cos( (j+1) * db );

  float x2 = r1 * sin( j * db );
  float z2 = r1 * cos( j * db );
  float x3 = r1 * sin( (j+1) * db );
  float z3 = r1 * cos( (j+1) * db );

  /*glColor3f((x0+x1+x2+x3)/4.0,(y0+y1)/2.0,(z0+z1+z2+z3)/4.0);*/
  glTexCoord2f (0.0f, 1.0f);
  glVertex3f(x0,y0,z0);

  glTexCoord2f (1.0f, 1.0f);
  glVertex3f(x1,y0,z1);

  glTexCoord2f (1.0f, 0.0f);
  glVertex3f(x3,y1,z3);

  glTexCoord2f (0.0f,0.0f);
  glVertex3f(x2,y1,z2);

 }
}
glEnd();
glEndList();
return;
}



void nCubeTeam(int num)
{
	glNewList(num,GL_COMPILE);
	glBegin(GL_QUADS);

	glTexCoord2f (0.0f, 1.0f);
	glVertex3f(-1.0, -1.0,  1.0);
	glTexCoord2f (1.0f, 1.0f);
	glVertex3f( 1.0, -1.0,  1.0);
	glTexCoord2f (1.0f, 0.0f);
	glVertex3f( 1.0,  1.0,  1.0);
	glTexCoord2f (0.0f,0.0f);
	glVertex3f(-1.0,  1.0,  1.0);

	/**# Back Face**/
	glTexCoord2f (1.0f, 1.0f);
	glVertex3f(-1.0, -1.0, -1.0);
	glTexCoord2f (1.0f, 0.0f);
	glVertex3f(-1.0,  1.0, -1.0);
	glTexCoord2f (0.0f,0.0f);
	glVertex3f( 1.0,  1.0, -1.0);
	glTexCoord2f (0.0f, 1.0f);
	glVertex3f( 1.0, -1.0, -1.0);

	/**# Top Face**/
 	glTexCoord2f (0.0f, 1.0f);
 	glVertex3f(-1.0,  1.0, -1.0);
 	glTexCoord2f (1.0f, 1.0f);
 	glVertex3f(-1.0,  1.0,  1.0);
 	glTexCoord2f (1.0f, 0.0f);
 	glVertex3f( 1.0,  1.0,  1.0);
 	glTexCoord2f (0.0f,0.0f);
 	glVertex3f( 1.0,  1.0, -1.0);

 	/** # Bottom Face**/
 	glTexCoord2f (0.0f, 1.0f);
 	glVertex3f(-1.0, -1.0, -1.0);
 	glTexCoord2f (1.0f, 1.0f);
 	glVertex3f( 1.0, -1.0, -1.0);
 	glTexCoord2f (1.0f, 0.0f);
 	glVertex3f( 1.0, -1.0,  1.0);
 	glTexCoord2f (0.0f,0.0f);
 	glVertex3f(-1.0, -1.0,  1.0);
	/**# Right face**/
	glTexCoord2f (1.0f, 1.0f);
	glVertex3f( 1.0, -1.0, -1.0);
	glTexCoord2f (1.0f, 0.0f);
	glVertex3f( 1.0,  1.0, -1.0);
	glTexCoord2f (0.0f,0.0f);
	glVertex3f( 1.0,  1.0,  1.0);
	glTexCoord2f (0.0f, 1.0f);
	glVertex3f( 1.0, -1.0,  1.0);
	/**# Left Face**/
	glTexCoord2f (0.0f, 1.0f);
	glVertex3f(-1.0, -1.0, -1.0);
	glTexCoord2f (1.0f, 1.0f);
	glVertex3f(-1.0, -1.0,  1.0);
	glTexCoord2f (1.0f, 0.0f);
	glVertex3f(-1.0,  1.0,  1.0);
	glTexCoord2f (0.0f,0.0f);
	glVertex3f(-1.0,  1.0, -1.0);
	glEnd();
	glEndList();
	return;
}

void nRectTeam(int num)
{
	glNewList(num,GL_COMPILE);
	glBegin(GL_QUADS);

	glTexCoord2f (0.0f, 1.0f);
	glVertex3f(-1.5, -1.0,  0.5);
	glTexCoord2f (1.0f, 1.0f);
	glVertex3f ( 1.5, -1.0,  0.5);
	glTexCoord2f (1.0f, 0.0f);
	glVertex3f( 1.5,  1.0,  0.5);
	glTexCoord2f (0.0f,0.0f);
	glVertex3f(-1.5,  1.0,  0.5);

	/**# Back Face**/
	glTexCoord2f (1.0f, 1.0f);
	glVertex3f(-1.5, -1.0, -0.5);
	glTexCoord2f (1.0f, 0.0f);
	glVertex3f(-1.5,  1.0, -0.5);
	glTexCoord2f (0.0f,0.0f);
	glVertex3f( 1.5,  1.0, -0.5);
	glTexCoord2f (0.0f,1.0f);
	glVertex3f( 1.5, -1.0, -0.5);

	/**# Top Face**/

	glTexCoord2f (0.0f, 1.0f);
	glVertex3f(-1.5,  1.0, -0.5);
	glTexCoord2f (1.0f, 1.0f);
	glVertex3f(-1.5,  1.0,  0.5);
	glTexCoord2f (1.0f, 0.0f);
	glVertex3f( 1.5,  1.0,  0.5);
	glTexCoord2f (0.0f,0.0f);
	glVertex3f( 1.5,  1.0, -0.5);



	/** # Bottom Face**/
	glTexCoord2f (0.0f, 1.0f);
	glVertex3f(-1.5, -1.0, -0.5);
	glTexCoord2f (1.0f, 1.0f);
	glVertex3f( 1.5, -1.0, -0.5);
	glTexCoord2f (1.0f, 0.0f);
	glVertex3f( 1.5, -1.0,  0.5);
	glTexCoord2f (0.0f,0.0f);
	glVertex3f(-1.5, -1.0,  0.5);


	/**# Right face**/
	glTexCoord2f (1.0f, 1.0f);
	glVertex3f( 1.5, -1.0, -0.5);
	glTexCoord2f (1.0f, 0.0f);
	glVertex3f( 1.5,  1.0, -0.5);
	glTexCoord2f (0.0f,0.0f);
	glVertex3f( 1.5,  1.0,  0.5);
	glTexCoord2f (0.0f, 1.0f);
	glVertex3f( 1.5, -1.0,  0.5);

	/**# Left Face**/
	glTexCoord2f (0.0f, 1.0f);
	glVertex3f(-1.5, -1.0, -0.5);
	glTexCoord2f (1.0f, 1.0f);
	glVertex3f(-1.5, -1.0,  0.5);
	glTexCoord2f (1.0f, 0.0f);
	glVertex3f(-1.5,  1.0,  0.5);
	glTexCoord2f (0.0f,0.0f);
	glVertex3f(-1.5,  1.0, -0.5);

	glEnd();
	glEndList();
	return;
}
